function RoW = RoW(z)

%FOR THE LONG-RUN INEQUALITY PROJECT

%function that takes the return R and solves a very simple RoW economy
global nA A a m alpha  nY sigma Amat R NFAP gdp varRoW rhoRoW betarow TFProw
    
load aprimerow
%aprimerow = asprime
%load auprime

z;%just a potential check
R = z;
%betarow = beta;

% NEW numbers Hakki added on 10-2016
r = R-(1-0.08);
pop = 9.3008; %Row pop size relative to US 1960s
pop = 11.0403; %Row pop size relative to US 2000s
L = 1/3*pop;
%size = 1.7589; %RoW GDP size relative to US 1960s
%size = 2.2468; %RoW GDP size relative to US 2000s
alpharow = 1/3;

K = L*(r/(TFProw*alpharow))^(1/(alpha-1));%holding TFP constant
w = K^alpharow*(1-alpharow)*TFProw*L^(-alpharow);

% holding relative size constant
% K = alpharow/r*size*gdp;
% TFProw = (size*gdp/(K^alpharow*L^(1-alpharow)));
% save TFProw TFProw
% w = (1-alpharow)*size*gdp/L;

Y = K^alpharow*TFProw*L^(1-alpharow);
Y/gdp;
Yrow = Y;
save Yrow Yrow



% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %constructing the one-dimensional wage vector
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %rouw = rouwenhorst(0.9, 0.015^.5, nY);
% rouw = rouwenhorst(rhoRoW, varRoW^.5, nY);
% Yrow = exp(rouw(1,:));
% Trow = rouw(2:nY+1,:);
% 
% %options.disp = 0;
% %[vector value] = eigs(Trow',1,1.1, options);
% %pirowSS = vector(:,1)/sum(vector(:,1))'
% 
% %defining after tax labor income to be used below
%  Ymat = (kron(Yrow*w, ones(nA,1)).*L);
%  %Yinv = (kron(Yrow*w, ones(nA,1)).*L)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%constructing the two-dimensional wage vector
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nY = nY^.5;
rouw = rouwenhorst(rhoRoW, varRoW^.5, nY);
Yeta = (rouw(1,:))'; Teta = rouw(2:nY+1,:);
rouw = rouwenhorst(0, 0.0399^.5, nY);
Ynu = (rouw(1,:))'; Tnu = rouw(2:nY+1,:);
Yrow = (exp(kron(Yeta, ones(length(Ynu),1))).*exp(kron(ones(length(Yeta),1),Ynu)));
Yrow = Yrow';
Trow = kron(Teta,Tnu);
Ymat = (kron(Yrow*w, ones(nA,1)).*L);
%normalizing not needed
nY = nY^2;
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%loop on finding policies given fixed prices
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
differ = 1;
n = 0;
nmax = 10^6;

%tic
while (differ > 10^-9)&(n<nmax);%everything in matrix form, time savings 1/9
    %seems a high precision is needed here,at least -9
    arow = (((betarow*R*Trow*((Ymat + R*Amat - aprimerow).^(-sigma))')').^(-1/sigma)+ Amat - Ymat)/R;

    ainvrow = arow;
    
    %Putting the new policy function back on the grid. Need an
    %approximation outside of the grid points for that.
    for k = 1:nA
       for m = 1:nY
           
           anewrow(k,m) = bfendo2(A(k), nA, m, arow)*A; %put everything in the function, global variables costly
           
        end
    end
    anewrow = max(anewrow, min(A));
    anewrow = min(anewrow, max(A)); 
    differ = sum(sum(abs(anewrow-aprimerow)));
    aprimerow = anewrow;
    
    
    %if differ > 10^-9
        save aprimerow aprimerow
       
    %end

    n = n + 1;
end
n;
if n == nmax;
n
end
n;
%display 'Solving for policies takes'
%toc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%here I am computing stat. distribution 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%display 'now computing the transition matrix'

diff = 1;
m=0;
a = Amat;

%tic
%this here only generates the transition matrix
    Tlambda = zeros(nA*nY, nA*nY);
    
    for i = 1:nA
        for m = 1:nY
            
             %this is the old version of this function, but this is not used many times
             lom = max(min(bfendo(aprimerow(i,m)),1),0);%to get probabilities in [0,1]
             
                                
             %mind the order here, don't compute the bfendo's unnecessarily

             for k = 1:nA
                for l = 1:nY
                    Tlambda(nY*(i-1)+m,nY*(k-1)+l) = lom(k)*Trow(m,l);
                    
                end
            end
            
            
            
        end
    end
%display 'Computing the transition matrix takes'
%toc

%Tlambda;



%tic;
%it is usually faster than the proceure without s, but seems not to work in some cases - need to verify eigen value = 1
options.disp = 0;
[vector value] = eigs(Tlambda.',1,1,options);
lambda = pop*vector(:,1)/sum(vector(:,1));
% [vector value] = eigs(Tlambdau.',1,1,options);
% lambdau = vector(:,1)/sum(vector(:,1))*piu;
%display 'Computing the stationary distribution takes'
%toc;
%bla


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Now we have the policies and stationary distributions, so we can compute
%steady state allocations.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%constructing labor policies
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambdamat = (reshape(lambda, nY, nA))';
%lambdaumat = (reshape(lambdau, nY, nA))';
%adding up accross productivity shocks to get the distribution accross asset states
lambdaa = sum(lambdamat,2);
%lambdaua = sum(lambdaumat,2);
%sum(sum(lambdasmat,2)) + sum(sum(lambdaumat,2))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%the new guesses
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%total (domestic) asset supply

Atemp = lambdaa'*A; 
NFAProw = Atemp - K;


RoW = NFAProw;