function simulation = simulation(cdfeta, Yeta, Tetacdf, cdfnu, Ynu, Tnucdf, cdfs, Ys, Tscdf, nY) 

%%%%%%%%% generates random sequence of the persistent component (eta) and then
%%%%%%%%% computes its persistence and volatility, spits out constant, rho,
%%%%%%%%% and var residual
simuln = 10000;

randometa(1) = unifrnd(0,1);
if randometa(1) < cdfeta(1)
    Yetareal(1) = (Yeta(1));
    etaeps(1) = 1;
else
    for i = 2:nY
        if randometa(1) >= cdfeta(i-1) & randometa(1)<cdfeta(i)
           Yetareal(1) = (Yeta(i));
           etaeps(1) = i;
        end
    end
end
for j = 2: simuln
    randometa(j) = unifrnd(0,1);
    if randometa(j) <Tetacdf(etaeps(j-1),1)
       Yetareal(j) = (Yeta(1));
       etaeps(j) = 1;
    else
        for i = 2:nY
            if randometa(j) >= Tetacdf(etaeps(j-1), i-1) & randometa(j)<Tetacdf(etaeps(j-1),i)
                Yetareal(j) = (Yeta(i));
                etaeps(j) = i;
            end
        end 
    end
end
Yetareal = Yetareal';
etaeps;

 temprho = regress(Yetareal(2:simuln), [ones(simuln-1,1), Yetareal(1:simuln-1)])
 tempres = Yetareal(2:simuln)- temprho(1)*ones(simuln-1,1) - temprho(2)*Yetareal(1:simuln-1);
 (std(tempres))^2
%%%%%%%%% generates random sequence of the transitory component (nu) and then
%%%%%%%%% computes its persistence and volatility
 
 randomnu(1) = unifrnd(0,1);
if randomnu(1) < cdfnu(1)
    Ynureal(1) = (Ynu(1));
    nueps(1) = 1;
else
    for i = 2:nY
        if randomnu(1) >= cdfnu(i-1) & randomnu(1)<cdfnu(i)
           Ynureal(1) = (Ynu(i));
           nueps(1) = i;
        end
    end
end
for j = 2: simuln
    randomnu(j) = unifrnd(0,1);
    if randomnu(j) <Tnucdf(nueps(j-1),1)
       Ynureal(j) = (Ynu(1));
       nueps(j) = 1;
    else
        for i = 2:nY
            if randomnu(j) >= Tnucdf(nueps(j-1), i-1) & randomnu(j)<Tnucdf(nueps(j-1),i)
                Ynureal(j) = (Ynu(i));
                nueps(j) = i;
            end
        end 
    end
end
Ynureal = Ynureal';
nueps;

 temprho = regress(Ynureal(2:simuln), [ones(simuln-1,1), Ynureal(1:simuln-1)])
 tempres = Ynureal(2:simuln)- temprho(1)*ones(simuln-1,1) - temprho(2)*Ynureal(1:simuln-1);
 (std(tempres))^2

%%%%%%%%% generates random sequence of the transitory component and then
%%%%%%%%% computes its persistence and volatility 
 
 
 randoms(1) = unifrnd(0,1);
if randoms(1) < cdfs(1)
    Ysreal(1) = (Ys(1));
    seps(1) = 1;
else
    for i = 2:nY^2
        if randoms(1) >= cdfs(i-1) & randoms(1)<cdfs(i)
           Ysreal(1) = (Ys(i));
           seps(1) = i;
        end
    end
end


for j = 2: simuln
    randoms(j) = unifrnd(0,1);
    if randoms(j) <Tscdf(seps(j-1),1)
       Ysreal(j) = (Ys(1));
       seps(j) = 1;
    else
        for i = 2:nY^2
            if randoms(j) >= Tscdf(seps(j-1), i-1) & randoms(j)<Tscdf(seps(j-1),i)
                Ysreal(j) = (Ys(i));
                seps(j) = i;
            end
        end 
    end
end
Ysreal = log(Ysreal)';
seps;

 temprho = regress(Ysreal(2:simuln), [ones(simuln-1,1), Ysreal(1:simuln-1)])
 tempres = Ysreal(2:simuln)- temprho(1)*ones(simuln-1,1) - temprho(2)*Ysreal(1:simuln-1);
 (std(tempres))^2

 %%%%%%%%% generates random sequence of the wage process (eta+nu) and then
%%%%%%%%% computes its persistence and volatility 
 
 %Yreal = exp(Yetareal+Ynureal)
 logYreal = (Yetareal+Ynureal);
 temprho = regress(logYreal(2:simuln), [ones(simuln-1,1), logYreal(1:simuln-1)])
 tempres = logYreal(2:simuln)- temprho(1)*ones(simuln-1,1) - temprho(2)*logYreal(1:simuln-1);
 (std(tempres))^2
 
  %meanexpeta = exp(Yeta)*pietaSS
  %meanexpnu = exp(Ynu)*pinuSS
  %Yreal = exp(logYreal)/(meanexpeta*meanexpnu);
  %mean(Yreal)



simulation = 0;