function aiyagaricalEE_final2 = aiyagaricalEE_final2(z)

%FOR THE LONG-RUN INEQUALITY PROJECT

%function that solves for equilibrium rs, wu, ws, and calibrates B, betas, betau, omega, nu, lambda, meany 
%in an Aiyagari model with complementarity and non-linear labor taxes. re is given by NAC
global nA A a m alpha eta omega rho nu k0 ds de lu ls rs re tauke tauks ks ke taul nY sigma Yu Ys open v phi delta pisentr piuentr ...
    lambdas lambdau lambdasa lambdaua gy x pis piu Ts Tu Amat Tlambdau Tlambdas tauc by lspol lambdal lupol lsinv luinv cspol cupol qe qs R TFP ...
    pitruesSS pitrueuSS pibetas pibetau sizebeta

load asprime
load auprime



z; %just a potential check

%defining variables
rs = z(1);
w = [z(2), z(3)];
lambdal = z(4);
B = z(5);
meany = z(6);
omega = z(7);
nu = z(8);
betas = z(9:10);
betau = z(11:12);


%sizebeta = length(betas);
% for b = 1:sizebeta
%     asprime(:,:,b) = asprime;
%     auprime(:,:,b) = auprime;
% end
% save asprime asprime
% save auprime auprime


%returns
re = (1-tauks)/(1-tauke)*qe/qs*(rs - qs*ds) + qe*de; % %the NAC %AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
R = 1+(rs-qs*ds)*(1-tauks)/qs;

for b = 1:sizebeta
    %defining after tax labor income to be used below
    Ysmat(:,:,b) = lambdal*(kron(Ys*w(2), ones(nA,1)).*lspol(:,:,b)/meany).^(1-taul)*meany;
    Yumat(:,:,b) = lambdal*(kron(Yu*w(1), ones(nA,1)).*lupol(:,:,b)/meany).^(1-taul)*meany;
    Ysinv(:,:,b) = lambdal*(kron(Ys*w(2), ones(nA,1)).*lsinv(:,:,b)/meany).^(1-taul)*meany;
    Yuinv(:,:,b) = lambdal*(kron(Yu*w(1), ones(nA,1)).*luinv(:,:,b)/meany).^(1-taul)*meany;

    Vsmat(:,:,b) = v(phi, lspol(:,:,b));
    Vumat(:,:,b) = v(phi, lupol(:,:,b));
    Vsinv(:,:,b) = v(phi, lsinv(:,:,b));
    Vuniv(:,:,b) = v(phi, luinv(:,:,b));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%loop on finding policies given fixed prices
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
differ = 1;
n = 0;
nmax = 10^6;

%tic
while (differ > 10^-9)&(n<nmax);%everything in matrix form, time savings 1/9
    %seems a high precision is needed here,at least -9
    
    %changes accounting for endogeneous education made in March 2016
    %as = (((delta*betas*R*Ts*((Ysmat + R*Amat - delta*asprime).^(-sigma).*Vsmat)')'./ Vsinv).^(-1/sigma)+ delta*Amat - Ysinv)/R;
    %au = (((delta*betau*R*Tu*((Yumat + R*Amat - delta*auprime).^(-sigma).*Vumat)')'./ Vuniv).^(-1/sigma)+ delta*Amat - Yuinv)/R;
    
    %correction gfollowing Ozlem's suggestion March 2021
    
    for b = 1:sizebeta
        as(:,:,b) = (((betas(b)*R*Ts*((Ysmat(:,:,b) + R*Amat - delta*asprime(:,:,b)).^(-sigma).*Vsmat(:,:,b))')'./ Vsinv(:,:,b)).^(-1/sigma)+ delta*Amat - Ysinv(:,:,b))/R;
        au(:,:,b) = (((betau(b)*R*Tu*((Yumat(:,:,b) + R*Amat - delta*auprime(:,:,b)).^(-sigma).*Vumat(:,:,b))')'./ Vuniv(:,:,b)).^(-1/sigma)+ delta*Amat - Yuinv(:,:,b))/R;
        
       % ainvs(:,:,b) = as(:,:,b);
       % ainvu(:,:,b) = au(:,:,b);
    end
    %as
    %au
    
    

    %Putting the new policy function back on the grid. Need an
    %approximation outside of the grid points for that.
    for b = 1:sizebeta
    for k = 1:nA
       for m = 1:nY
           asnew(k,m,b) = bfendo2(A(k), nA, m, as(:,:,b))*A; %put everything in the function, global variables costly
           aunew(k,m,b) = bfendo2(A(k), nA, m, au(:,:,b))*A; 
        end
    end
    end
    
    asnew = max(asnew, min(A));
    asnew = min(asnew, max(A)); 
    aunew = max(aunew, min(A));
    aunew = min(aunew, max(A)); 
    differ = sum(sum([sum(abs(asnew-asprime)), sum(abs(aunew-auprime))]));
    %bla  
    asprime = asnew;
    auprime = aunew;  
    
    %if differ > 10^-9
        save asprime asprime
        save auprime auprime
    %end

    n = n + 1;
end
n;
if n == nmax;
n
end
%n
%display 'Solving for policies takes'
%toc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%here I am computing stat. distribution 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%display 'now computing the transition matrix'

diff = 1;
m=0;
a = Amat;

%tic
%this here only generates the transition matrix
%Tlambda structure is: [A1-Z1; A1-Z2; ... A1-Z9; A2-Z1; A2-Z2; ... A2-Z9; ...]
    Tlambdas = zeros(nA*nY, nA*nY, sizebeta);
    Tlambdau = zeros(nA*nY, nA*nY, sizebeta);
    for b = 1:sizebeta
    for i = 1:nA
        for m = 1:nY
            
             %this is the old version of this function, but this is not used many times
             loms(:,b) = max(min(bfendo(asprime(i,m,b)),1),0);%to get probabilities in [0,1]
             lomu(:,b) = max(min(bfendo(auprime(i,m,b)),1),0);
                                
             %mind the order here, don't compute the bfendo's unnecessarily
 
             for k = 1:nA
                for l = 1:nY %adjusting for death ...
                    
                    Tlambdas(nY*(i-1)+m,nY*(k-1)+l,b) = delta*loms(k,b)*Ts(m,l);
                    Tlambdau(nY*(i-1)+m,nY*(k-1)+l,b) = delta*lomu(k,b)*Tu(m,l);
                end
            end
         
            
            
        end
    end
    
%display 'Computing the transition matrix takes'
%toc
%adjusting for newborns ...
 Tlambdas(:, 1:nY,b) = Tlambdas(:, 1:nY,b) + kron(pisentr', ones(nA*nY,1))*(1-delta);
 Tlambdau(:, 1:nY,b) = Tlambdau(:, 1:nY,b) + kron(piuentr', ones(nA*nY,1))*(1-delta);
    
  
    
%sum(Tlambdas(:,:,b),2)
%sum(Tlambdau(:,:,b),2)
    
    
%    Tlambdas
%    Tlambdau
%bla


%tic;
%it is usually faster than the proceure without s, but seems not to work in some cases - need to verify eigen value = 1
%what about some guesses???
options.disp = 0;
[vector value] = eigs(Tlambdas(:,:,b).',1,1,options);
lambdas(:,b) = vector(:,1)/sum(vector(:,1))*pis*pibetas(b);
[vector value] = eigs(Tlambdau(:,:,b).',1,1,options);
lambdau(:,b) = vector(:,1)/sum(vector(:,1))*piu*pibetau(b);
%display 'Computing the stationary distribution takes'
%toc;
    






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Now we have the policies and stationary distributions, so we can compute
%steady state allocations.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%constructing labor policies
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambdasmat(:,:,b) = (reshape(lambdas(:,b), nY, nA))';
lambdaumat(:,:,b) = (reshape(lambdau(:,b), nY, nA))';

    
%adding up accross productivity shocks and beta to get the distribution accross asset states
lambdasa(:,b) = sum(lambdasmat(:,:,b),2);
lambdaua(:,b) = sum(lambdaumat(:,:,b),2);
%sum(sum(lambdasmat,2)) + sum(sum(lambdaumat,2))

    end
    lambdasa = sum(lambdasa,2);
    lambdaua = sum(lambdaua,2);
    %sum(lambdasa);
    %sum(lambdaua);
  
    
    
    %aggregate effective labors
ls = sum(sum(sum(kron(Ys, ones(nA,1)).*lambdasmat.*lspol)));
lu = sum(sum(sum(kron(Yu, ones(nA,1)).*lambdaumat.*lupol)));

%average labor
%l1 = sum(sum(lambdasmat.*lspol))/pis;
%l2 = sum(sum(lambdaumat.*lupol))/piu;
lagg = sum(sum(sum(lambdasmat.*lspol+lambdaumat.*lupol)));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%the new guesses
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%total (domestic) asset supply

Atemp = lambdasa'*A + lambdaua'*A - B;
if Atemp<0
    display 'Capital is negative.'
end

if open == 0;
    Knew = Atemp;
    k0 = Knew;
    %finding the individual ke and ks s.t. the nac holds
    options = optimset('display', 'off', 'tolfun', 10^(-20), 'tolX', 10^(-20), 'maxfunevals', 1000000, 'maxiter', 1000000);
    ke = fsolve(@nacdiffPER2, .5*k0, options)/qe; %AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    ks = (k0 - ke*qe)/qs;
elseif open == 1;
    %given ls and lu, find ke and ks that make sure the return is right
    options = optimset('display', 'off', 'tolfun', 10^(-20), 'tolX', 10^(-20), 'maxfunevals', 1000000, 'maxiter', 1000000);
    ktemp = fsolve(@ycompprimeopen, [.5, .5] * Atemp, options);
    ks = ktemp(1);
    ke = ktemp(2);
    Knew = qs*ks+qe*ke;
end

x = [ks, ke, lu, ls];
gdp = ycomp(x);
KtoY = Knew/gdp;
Keshare = qe*ke/Knew;

%cagg = sum(sum(lambdasmat.*cspol)) + sum(sum(lambdaumat.*cupol));
%check2 = gdp-cagg - de*ke - ds*ks - G 

%constructing the new prices and transfers
MP = ycompprime2(x);
rsnew = MP(1);
renew = MP(2);
Rnew = 1+(rsnew-ds*qs)*(1-tauks)/qs; %AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
wnew = [MP(3), MP(4)];
gdpnew = ycomp(x); 
Bnew = by*gdpnew;

%mean pretax labor income for the tax function
for b = 1:sizebeta
    pres(:,:,b) = kron(Ys*wnew(2), ones(nA,1)).*lspol(:,:,b);
    preu(:,:,b) = kron(Yu*wnew(1), ones(nA,1)).*lupol(:,:,b);
end
meanynew = sum(sum(sum(lambdasmat.*pres+lambdaumat.*preu)));


for b = 1:sizebeta
%aftertax income given new wages and new mean income
Ysmat(:,:,b)  = lambdal*(kron(Ys*wnew(2), ones(nA,1)).*lspol(:,:,b) /meanynew).^(1-taul)*meanynew;
Yumat(:,:,b)  = lambdal*(kron(Yu*wnew(1), ones(nA,1)).*lupol(:,:,b) /meanynew).^(1-taul)*meanynew;

%aggregate consumption in new prices
cspol(:,:,b)  = (Rnew*kron(A,ones(1,nY))-delta*asprime(:,:,b)  + Ysmat(:,:,b) )/(1+tauc);
cupol(:,:,b)  = (Rnew*kron(A,ones(1,nY))-delta*auprime(:,:,b)  + Yumat(:,:,b) )/(1+tauc);


end
cagg = sum(sum(sum(lambdasmat.*cspol + lambdaumat.*cupol)));

%labor income taxes
taxs = pres - Ysmat;
taxu = preu - Yumat;
ltagg = sum(sum(sum(lambdasmat.*taxs + lambdaumat.*taxu)));

%gvt budget to pin down tauk %%%%%CHECK THIS HAKKI!!!
budget = tauc*cagg + ltagg + tauks*(rsnew-qs*ds)*ks + tauke*(renew-qe*de)*ke - gy*gdpnew - (Rnew-1)*B; %AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA

%targets in the calibration procedure
sp = (Ys*pitruesSS*w(2))/(Yu*pitrueuSS*w(1)); %works whether or not mean Y is 1 in each occupation
lshare = (lu*wnew(1) + ls*wnew(2))/gdp;
rks = lambdasa'*A/pis/(lambdaua'*A/piu);

NFAP = (Atemp - Knew)/Atemp;




 
 %finding the unskilled asset gini
 asset = A.*lambdaua/piu;
 si = cumsum(asset,1);
 siminus = [0; si(1:nA-1)];
 Giniau = 1 - (lambdaua'*(si+siminus))/si(nA)/piu;
 
 
  %finding the skilled asset gini
 asset = A.*lambdasa/pis;
 si = cumsum(asset,1);
 siminus = [0; si(1:nA-1)];
 Ginias = 1 - (lambdasa'*(si+siminus))/si(nA)/pis;
 
%finding the asset gini
 lambdaa = lambdaua + lambdasa;
 asset = A.*lambdaa;
 si = cumsum(asset,1);
 siminus = [0; si(1:nA-1)];
 Giniasset = 1 - (lambdaa'*(si+siminus))/si(nA) ;

  
% lambdaacdf = cumsum(lambdasa)+ cumsum(lambdaua);
% 
%  %computing asset quintiles (i.e. share of total asset holdings for the whole quintile)
%  mat = [lambdaacdf, A];
%  %pickquint = [.2,.4,.6,.8];
%  pickquint = [.6, .9];
%  for nn = 1:length(pickquint);
%     for ii = 1:nA
%         if  lambdaacdf(ii) > pickquint(nn);
%             mat(nA+nn,:) = [pickquint(nn), A(ii)];
%         break
%         end
%     end
%  end
%  matsort = sortrows(mat,1);
 

 
 
%  templambdaa = matsort(:,1) - [0;matsort(1:size(matsort,1)-1,1)];
%  quint = matsort(:,1)*ones(1,length(pickquint)) - kron(pickquint, ones(nA+length(pickquint),1));
%  quint = quint <= 0;
%  quintiles = [sum(( matsort(:,2)*ones(1,length(pickquint))).*quint.*(templambdaa*ones(1,length(pickquint))))/si(nA),1];
%  assetquintiles = quintiles - [0, quintiles(1:length(pickquint))]
%   
%  top10 = assetquintiles(3);
%  bottom60 = assetquintiles(1);

 

if open == 0;
bla
     
     aiyagaricalEE_final2 = [rs - rsnew, w - wnew, budget, B - Bnew, sp - 1.5, KtoY - 2, lshare - .67, meany - meanynew,  rks - 3.13, Giniau - 0.77, Ginias - 0.77];
elseif open ==1;
     aiyagaricalEE_final2 = [NFAP - 0.018, w - wnew, budget, B - Bnew, sp - 1.5, KtoY - 1.87, lshare - .67, meany - meanynew,  rks - 3.35, Giniau - 0.77, Ginias - 0.75];
 end

%CANNOT CALIBRATE PHI HERE, SINCE LABOR IS FIXED